```
# load data
load("~/exedatabase_v1.5/mouse_ncRNA.RData")
load("~/exedatabase_v1.5/all_pd.RData")
.libPaths(c('~/R/x86_64-pc-linux-gnu-library/4.2',
            '/home/data/refdir/Rlib',
            '/usr/local/lib/R/library'))
library(stringr)
library(limma)
ncrna_mouse.pd$label_tec <- paste0(ncrna_mouse.pd$SeqTech,ncrna_mouse.pd$SeqType,ncrna_mouse.pd$Series_id)
ncrna_mouse.pd$label_cli <- paste0(ncrna_mouse.pd$Organism,ncrna_mouse.pd$Strain_char1,ncrna_mouse.pd$`Tissue_char1/Cell_type`,
                                   ncrna_mouse.pd$Age_char2,ncrna_mouse.pd$Gender,ncrna_mouse.pd$Health_condition)
ncrna_mouse.pd$label_exe <- paste0(ncrna_mouse.pd$Group,ncrna_mouse.pd$Exe_Time,ncrna_mouse.pd$Exe_Freq,ncrna_mouse.pd$Exe_Intensity,
                                   ncrna_mouse.pd$Exe_Modality,ncrna_mouse.pd$Exe_Duration,ncrna_mouse.pd$Sampling_Time)


all.out.table <- data.frame(Gene_Symbol = 1,AveExpr = 1,logFC = 1,Pvalue = 1,adjP = 1,
                            Organ = 1, Age = 1, Gender = 1,Strain_char1 = 1,Strain_char2 =1,
                            Tissue_char1 = 1, Tissue_char2 = 1,
                            Health_condition = 1, Series_id = 1,
                            SeqTech = 1, SeqType = 1, Exe_Modality = 1, Exe_Freq = 1, Exe_Time = 1,
                            Exe_Duration = 1, Exe_Intensity = 1,Sampling_Time = 1)

exp.file <- ls()[str_detect(ls(),"ncRNA")][str_detect(ls()[str_detect(ls(),"ncRNA")],"GSE")]
used.sample <- c()
for (i in exp.file) {
  exp <- get(i)
  common_sample <- intersect(colnames(exp),rownames(ncrna_mouse.pd))
  pd <- ncrna_mouse.pd[common_sample,]
  exp <- exp[,common_sample]
  

  sed.pd <- subset(pd,Group == "Sedentary")
  exe.pd <- subset(pd,Group == "Exercise")
  sed.pd$label <- paste0(sed.pd$label_tec,sed.pd$label_cli,sed.pd$label_exe)
  exe.pd$label <- paste0(exe.pd$label_tec,exe.pd$label_cli,exe.pd$label_exe)
  

  for (j in unique(exe.pd$label)) {
    sub.exe <- subset(exe.pd,label == j)
    sub.sed <- subset(sed.pd,label_cli == unique(sub.exe$label_cli) & label_tec == unique(sub.exe$label_tec))

    if (length(sub.exe$label) > 2 & length(sub.exe$label) > 2) {
      EXP <- exp[,c(rownames(sub.exe),rownames(sub.sed))]
      GROUP <- rep(c("Exercise","Sedentary"),
                   c(length(rownames(sub.exe)),length(rownames(sub.sed))))
      # DEG analysis
      design <- model.matrix(~0+factor(GROUP))
      colnames(design)=levels(factor(GROUP))
      rownames(design)=colnames(EXP)
      contrast.matrix<-makeContrasts(paste0(c("Exercise","Sedentary"),collapse = "-"),levels = design)
      contrast.matrix
      fit <- lmFit(EXP,design)
      fit2 <- contrasts.fit(fit, contrast.matrix)
      fit2 <- eBayes(fit2)
      tempOutput = topTable(fit2, coef=1, n=Inf)
      DEG = na.omit(tempOutput)

      out.table <- data.frame(Gene_Symbol = rownames(DEG),AveExpr = DEG$AveExpr,logFC = DEG$logFC,Pvalue = DEG$P.Value,adjP = DEG$adj.P.Val,
                                         Organ = unique(sub.exe$Organism), Age = unique(sub.exe$Age_char2), Gender = unique(sub.exe$Gender),
                                         Strain_char1 = unique(sub.exe$Strain_char1),Strain_char2 =unique(sub.exe$Strain_char2),
                                         Tissue_char1 = unique(sub.exe$Tissue_char1),Tissue_char2 = unique(sub.exe$Tissue_char2),
                                         Health_condition = unique(sub.exe$Health_condition), Series_id = unique(sub.exe$Series_id),
                                         SeqTech = unique(sub.exe$SeqTech), SeqType = unique(sub.exe$SeqType), Exe_Modality = unique(sub.exe$Exe_Modality),
                                         Exe_Freq = unique(sub.exe$Exe_Freq), Exe_Time = unique(sub.exe$Exe_Time),
                                         Exe_Duration = unique(sub.exe$Exe_Duration), Exe_Intensity = unique(sub.exe$Exe_Intensity),
                                         Sampling_Time = unique(sub.exe$Sampling_Time))
      
      all.out.table <- rbind(all.out.table,out.table)
      used.sample <- c(used.sample,colnames(EXP))
    }else{
      print(paste0(i,"has a wrong group:",j))
    }
  }
}
all.out.table <- all.out.table[-1,]
ncrna_mouse.deg <- all.out.table


colnames(ncrna_mouse.deg) <- c("Gene_Symbol","Average_expression","logFC","P.Value","adj.P.Value","Organism","Age","Gender",
                         "Strain_char1","Strain_char2","Tissue_char1","Tissue_char2","Health_condition","Series_id",
                         "SeqTech","SeqType","Exe_Modality","Exe_Freq",
                         "Exe_Time","Exe_Duration","Exe_Intensity","Sampling_Time")

# save(ncrna_mouse.deg,file = "~/exedatabase_v1.5/ncrna_mouse_deg.RData")
# save(ncrna_mouse.pd,file = "~/exedatabase_v1.5/ncrna_mouse_pd.RData")



#load data
load("~/exedatabase_v1.5/mouse_mRNA.RData")
load("~/exedatabase_v1.5/all_pd.RData")
.libPaths(c('~/R/x86_64-pc-linux-gnu-library/4.2',
            '/home/data/refdir/Rlib',
            '/usr/local/lib/R/library'))
library(stringr)
library(limma)
mrna_mouse.pd$label_tec <- paste0(mrna_mouse.pd$SeqTech,mrna_mouse.pd$SeqType,mrna_mouse.pd$Series_id)
mrna_mouse.pd$label_cli <- paste0(mrna_mouse.pd$Organism,mrna_mouse.pd$Strain_char1,mrna_mouse.pd$`Tissue_char1/Cell_type`,
                                   mrna_mouse.pd$Age_char2,mrna_mouse.pd$Gender,mrna_mouse.pd$Health_condition)
mrna_mouse.pd$label_exe <- paste0(mrna_mouse.pd$Group,mrna_mouse.pd$Exe_Time,mrna_mouse.pd$Exe_Freq,mrna_mouse.pd$Exe_Intensity,
                                   mrna_mouse.pd$Exe_Modality,mrna_mouse.pd$Exe_Duration,mrna_mouse.pd$Sampling_Time)

all.out.table <- data.frame(Gene_Symbol = 1,AveExpr = 1,logFC = 1,Pvalue = 1,adjP = 1,
                            Organ = 1, Age = 1, Gender = 1,Strain_char1 = 1,Strain_char2 =1,
                            Tissue_char1 = 1, Tissue_char2 = 1,
                            Health_condition = 1, Series_id = 1,
                            SeqTech = 1, SeqType = 1, Exe_Modality = 1, Exe_Freq = 1, Exe_Time = 1,
                            Exe_Duration = 1, Exe_Intensity = 1,Sampling_Time = 1)

exp.file <- ls()[str_detect(ls(),"mRNA")][str_detect(ls()[str_detect(ls(),"mRNA")],"GSE")]
used.sample <- c()
for (i in exp.file) {
  exp <- get(i)
  common_sample <- intersect(colnames(exp),rownames(mrna_mouse.pd))
  pd <- mrna_mouse.pd[common_sample,]
  exp <- exp[,common_sample]
  sed.pd <- subset(pd,Group == "Sedentary")
  exe.pd <- subset(pd,Group == "Exercise")
  sed.pd$label <- paste0(sed.pd$label_tec,sed.pd$label_cli,sed.pd$label_exe)
  exe.pd$label <- paste0(exe.pd$label_tec,exe.pd$label_cli,exe.pd$label_exe)
  
  for (j in unique(exe.pd$label)) {
    sub.exe <- subset(exe.pd,label == j)
    sub.sed <- subset(sed.pd,label_cli == unique(sub.exe$label_cli) & label_tec == unique(sub.exe$label_tec))

    if (length(sub.exe$label) > 2 & length(sub.exe$label) > 2) {
      EXP <- exp[,c(rownames(sub.exe),rownames(sub.sed))]
      GROUP <- rep(c("Exercise","Sedentary"),
                   c(length(rownames(sub.exe)),length(rownames(sub.sed))))
      # DEG analysis
      design <- model.matrix(~0+factor(GROUP))
      colnames(design)=levels(factor(GROUP))
      rownames(design)=colnames(EXP)
      contrast.matrix<-makeContrasts(paste0(c("Exercise","Sedentary"),collapse = "-"),levels = design)
      contrast.matrix
      fit <- lmFit(EXP,design)
      fit2 <- contrasts.fit(fit, contrast.matrix)
      fit2 <- eBayes(fit2)
      tempOutput = topTable(fit2, coef=1, n=Inf)
      DEG = na.omit(tempOutput)

      out.table <- data.frame(Gene_Symbol = rownames(DEG),AveExpr = DEG$AveExpr,logFC = DEG$logFC,Pvalue = DEG$P.Value,adjP = DEG$adj.P.Val,
                              Organ = unique(sub.exe$Organism), Age = unique(sub.exe$Age_char2), Gender = unique(sub.exe$Gender),
                              Strain_char1 = unique(sub.exe$Strain_char1),Strain_char2 =unique(sub.exe$Strain_char2),
                              Tissue_char1 = unique(sub.exe$Tissue_char1),Tissue_char2 = unique(sub.exe$Tissue_char2),
                              Health_condition = unique(sub.exe$Health_condition), Series_id = unique(sub.exe$Series_id),
                              SeqTech = unique(sub.exe$SeqTech), SeqType = unique(sub.exe$SeqType), Exe_Modality = unique(sub.exe$Exe_Modality),
                              Exe_Freq = unique(sub.exe$Exe_Freq), Exe_Time = unique(sub.exe$Exe_Time),
                              Exe_Duration = unique(sub.exe$Exe_Duration), Exe_Intensity = unique(sub.exe$Exe_Intensity),
                              Sampling_Time = unique(sub.exe$Sampling_Time))
      
      all.out.table <- rbind(all.out.table,out.table)
      used.sample <- c(used.sample,colnames(EXP))
    }else{
      print(paste0(i,"has a wrong group:",j))
    }
  }
}
all.out.table <- all.out.table[-1,]
mrna_mouse.deg <- all.out.table
pd <- mrna_mouse.pd[unique(used.sample),1:20]
mrna_mouse.pd <- pd


colnames(mrna_mouse.deg) <- c("Gene_Symbol","Average_expression","logFC","P.Value","adj.P.Value","Organism","Age","Gender",
                               "Strain_char1","Strain_char2","Tissue_char1","Tissue_char2","Health_condition","Series_id",
                               "SeqTech","SeqType","Exe_Modality","Exe_Freq",
                               "Exe_Time","Exe_Duration","Exe_Intensity","Sampling_Time")

# save(mrna_mouse.deg,file = "~/exedatabase_v1.5/mrna_mouse_deg.RData")
# save(mrna_mouse.pd,file = "~/exedatabase_v1.5/mrna_mouse_pd.RData")








```

