```
##挑出芯片数据
source("./helper_functions_classification.R")
load("./all_human_data.Rdata")

GSE <- unique(new.human.pd[new.human.pd$SeqType=="mRNA",5])

exp_list <- list()
for (i in 1:length(GSE))
{x <- get(GSE[i])
l <- list(x)
names(l)="gene_data"
exp_list[[i]]<- l
}

pd_list <- list()
for (i in 1:length(GSE))
     {
       x <- GSE[i]
       pd <- as.data.frame(new.human.pd[new.human.pd$Series_id==GSE[i],])
       
       l <- list(gender=pd$Gender,tissue=pd$Tissue_char2,
                 gsm=as.character(pd$Sample_id),
                 gse=pd$Series_id,Organism="Homo sapiens")
       
       pd_list[[i]]<- l
}

names(pd_list) <-GSE
names(exp_list) <- GSE

ge_matrices1 = lapply(exp_list,function(x)x$gene_data)

gsms = unlist(sapply(pd_list, function(x)x$gsm))

sex= unlist(sapply(pd_list, function(x)x$gender))
length(gsms)

gses1 = unlist(sapply(pd_list, function(x)x$gse))
names(gses1) <- gses1 
names(gsms)<- gses1 
names(sex) <- gsms
tissue1 = unlist(sapply(pd_list, function(x)x$tissue))
length(gsms)             
names(gsms)
##性别信息
table(sex)

NAgender <- names(sex1[is.na(sex1)])
#性别未缺失的样本
samples = names(sex1[!is.na(sex1)])

##把样本整合起来
get_list_intersect<-function(l){
  x = l[[1]]
  for(i in 1:length(l)){
    x = intersect(x,l[[i]])
  }
  return(x)
}

gene_lists = lapply(ge_matrices1,rownames)
all_genes = get_list_intersect(gene_lists)
length(all_genes)
# remove the worst dataset at a time
included_datasets = names(ge_matrices1)
low_coverage_platforms = c()
while(length(included_datasets)>1){
  curr_sizes = c()
  for(j in 1:length(included_datasets)){
    curr_sizes[j] = length(get_list_intersect(gene_lists[included_datasets[-j]]))
  }
  ind = which(curr_sizes==max(curr_sizes))[1]
  excluded = included_datasets[ind]
  included_datasets = included_datasets[-ind]
  all_genes = get_list_intersect(gene_lists[included_datasets])
  print(paste(length(all_genes),excluded))
  low_coverage_platforms = c(low_coverage_platforms,excluded)
  if(length(all_genes)>0){break}
}

# Merge the gene expression profiles
x = data.frame(gene=all_genes)
z = c();
for(nn in setdiff(names(ge_matrices1),low_coverage_platforms)){
  #for(nn in names(ge_matrices1)){
  currx = ge_matrices1[[nn]][all_genes,]
  x = cbind(x,currx)
  currz = rep(gses1[nn],ncol(currx))
  z[colnames(currx)] = currz
}



x <- x[,-1]
dim(x)
length(intersect(colnames(x),sex_df$GSM))
samples2 <- intersect(colnames(x),sex_df$GSM)
sex2 <- sex_df[samples2,3]
length(sex2)
table(is.na(sex2))

y_train <- x[,samples2]



# get the Y chromosome genes
library(GenomicRanges)
library(Homo.sapiens)
library(DESeq2)
geneRanges <- function(db=Homo.sapiens, column="SYMBOL"){
  g <- genes(db, columns=column)
  col <- mcols(g)[[column]]
  genes <- granges(g)[rep(seq_along(g), elementNROWS(col))]
  mcols(genes)[[column]] <- as.character(unlist(col))
  genes
}
entrez_gr = geneRanges(Homo.sapiens, column="SYMBOL")
entrez_gr = as.data.frame(entrez_gr)
selected_genes = entrez_gr[entrez_gr$seqnames=="chrY" | entrez_gr$seqnames=="chrX","SYMBOL"]

#确定特征基因的大体范围及矩阵
y_train <- y_train[selected_genes,]
y_train <- na.omit(y_train)
sample_train <- colnames(y_train)

##划分训练集和测试集
# 定义划分比例
train_ratio <- 0.7
test_ratio <- 1 - train_ratio



# 获取数据集的行数
df <- t(y_train)
n <- nrow(df)

# 随机排列数据集的行索引
indices <- sample(n)

# 根据比例划分数据集
train_size <- floor(train_ratio * n)
train_indices <- indices[1:train_size]
test_indices <- indices[(train_size + 1):n]

# 划分数据集
train_data <- df[train_indices, ]
test_data <- df[test_indices, ]

# 检查划分的结果
cat("训练集大小：", nrow(train_data), "\n")
cat("测试集大小：", nrow(test_data), "\n")


library(caret)

preproc <- preProcess(test_data, method = c("center", "scale")) 
test_data <- predict(preproc, newdata = test_data)




source('msvmRFE.R')   #文件夹内自带
library(VennDiagram)
library(sigFeature)
library(e1071)
library(caret)
library(randomForest)
#library(e1071)
#source(msvmRFE.R)
train_label <- as.factor(sex_df[rownames(normalized_data),3])
input <- cbind(train_label,normalized_data)

z = z[rownames(input)]

#采用五折交叉验证 (k-fold crossValidation）
svmRFE(input, k = 5, halve.above = 100) #分割数据，分配随机数
nfold = 5
nrows = nrow(input)
folds = rep(1:nfold, len=nrows)[sample(nrows)]
folds = lapply(1:nfold, function(x) which(folds == x))
results = lapply(folds, svmRFE.wrap, input, k=5, halve.above=100) #特征选择
top.features = WriteFeatures(results, input, save=F) #查看主要变量
head(top.features)
featsweep = lapply(1:5, FeatSweepQ.wrap, results, input) #48个变量
fina_gene <- top.features[1:50,1]
fina_train_data <- normalized_data[,top.features[1:100,1]]
test_data <- test_data[,top.features[1:100,1]]

train_label <- as.factor(sex_df[rownames(fina_train_data),3])

table(is.na())
z <- z[rownames(fina_train_data)]
z <- unique(z)
lso_res_newx_sex = leave_study_out2(train_label,
                                   fina_train_data,z,
                                   func = svm,class.weights=c("female"=10,"male"=1),
                                   pred_args=list(probability=T),probability=T,kernel="linear")




preds = c()
lso_res = lso_res_newx_sex
for(nn in names(lso_res)){
  preds = rbind(preds,cbind(
    as.numeric(lso_res[[nn]]$real == "female"),
    attr(lso_res[[nn]]$preds,"probabilities")[,"female"]))
}

library(pROC)
library(CMA)
boxplot(preds[,2]~preds[,1])
calcAupr(preds[,2],preds[,1])
calcAupr(preds[,2],preds[,1],roc = T,useAbs = T)
as.numeric(pROC::auc(preds[,1], preds[,2])




#对预测结果画ROC图
P <- data.frame(preds)
library(ROCR)
pred <- prediction(predictions = P$X2, 
                   labels = P$X1);

perf <- performance(prediction.obj = pred,
                    measure = "tpr",
                    x.measure = "fpr")
perf

plot(perf,colorize=TRUE,
     main="ROCR fingerpainting toolkit",
     xlab="Mary's axis", ylab="", 
     box.lty=7, box.lwd=2, box.col="gray")
auc<-  performance(pred,"auc")
auc_area<-slot(auc,"y.values")[[1]]

svm_model = svm(x=fina_train_data,y=as.factor(train_label),
                kernel="linear",class.weights=c("female"=10,"male"=1))

preds = predict(svm_model,test_data)
test_lable <- sex_df[rownames(test_data),3]
yy <- cbind(as.data.frame(preds),as.data.frame(test_lable))
# Assuming preds and test_label are defined
accuracy <- mean(yy$preds == yy$test_lable) * 100

table(preds)
table(test_lable)

#在测试集上预测
sex1
preproc <- preProcess(fina_test, method = c("center", "scale")) 
fina_test_data <- predict(preproc, newdata = fina_test)
fina_test_data <- test_data[,fina_gene]
test_lable <- as.factor(sex1[rownames(test_data)])
gene <- intersect(colnames(fina_test),top.features[,1])
top.features <- top.features[gene,]
fina_test <- t(GSE27543)
fina_test <- fina_test[,top.features[1:100,1]]
preds = predict(svm_model,fina_test)
table(top.features[1:100,1]%in%colnames(fina_test))

```

